<?
  include "xinabse-api.php";
  //CHANGE THIS TO MATCH YOUR INSTALLATION:
  $XINABSE_SERVER = "localhost";
  $XINABSE_DATABASE = "xinabse";
  $XINABSE_USER = "www";
  $XINABSE_PASSWD = "leech";
  //set this to 1 if you want some debugs in the HTML source
  $XINABSE_DEBUG = 0;

  // ----------------- NO CHANGES BELOW! ------------------
  $q     = $_REQUEST['q'];
  $all   = $_REQUEST['all'];
  $start = $_REQUEST['start'];
  $limit = $_REQUEST['limit'];

  //Template Definition with some security
  $tpl = preg_replace("/\.\./","",$tpl);
  $tpl = preg_replace("/^\//","",$tpl);
  if(empty($tpl))   $tpl   = "xinabse.tpl";
  xinabse_debug("Template to load",$tpl);
    
  // check parameters and set defaults
  if(!isset($start)) $start = 0;
  if(!isset($limit)) $limit = 20;

  //prepare resultarray
  $result = array();

  //search 
  if(!empty($q)){
    $rowcount = xinabse($q,&$result,$all,$start,$limit);
  }

  //load template
  $tpl_full = @join("",@file($tpl)) or die("Couldn't load template");
  
  //find RESULT block
  preg_match("/{BEGIN RESULT}(.*){END RESULT}/si",$tpl_full,$matches);
  $tpl_result = $matches[1];
  $tpl_full = preg_replace("/{BEGIN RESULT}(.*){END RESULT}/si","{RESULT}",$tpl_full);

  //find NORESULT block
  preg_match("/{BEGIN NORESULT}(.*){END NORESULT}/si",$tpl_full,$matches);
  $tpl_noresult = $matches[1];
  $tpl_full = preg_replace("/{BEGIN NORESULT}(.*){END NORESULT}/si","{NORESULT}",$tpl_full);

  //find RESULTROW block  
  preg_match("/{BEGIN RESULTROW}(.*){END RESULTROW}/si",$tpl_result,$matches);
  $tpl_row = $matches[1];
  $tpl_result = preg_replace("/{BEGIN RESULTROW}(.*){END RESULTROW}/si","{RESULTROW}",$tpl_result);

  //prepare resultrows
  foreach ($result as $row){
    $temprow = $tpl_row;
    $temprow = preg_replace("/{TITLE}/si",       htmlentities($row->title)       ,$temprow);
    $temprow = preg_replace("/{LASTMODIFIED}/si",$row->lastmodified,$temprow);
    $temprow = preg_replace("/{URL}/si",         $row->url         ,$temprow);
    $temprow = preg_replace("/{EXTRACT}/si",     htmlentities($row->extract)     ,$temprow);
    $temprow = preg_replace("/{WEIGHT}/si",      $row->weight      ,$temprow);
    $temprow = preg_replace("/{DOMAIN}/si",      $row->domain      ,$temprow);
    $temprow = preg_replace("/{PATH}/si",        $row->path        ,$temprow);
    $temprow = preg_replace("/{PAGE}/si",        $row->page        ,$temprow);
    $temprow = preg_replace("/{NUMBER}/si",      $row->number      ,$temprow);
    $temprow = preg_replace("/{RELEVANCE}/si",   $row->relevance   ,$temprow);
    $resultrows .= $temprow;
  }

  if(empty($q)){
    //no query neither RESULT nor NORESULT gets filled
    //just remove these blocks
    $tpl_full = preg_replace("/{RESULT}/si","",$tpl_full);
    $tpl_full = preg_replace("/{NORESULT}/si","",$tpl_full);
    xinabse_debug("using block","none");
  }else if($rowcount){
    //if there were hits fill RESULT block
    $tpl_result = preg_replace("/{RESULTROW}/si",$resultrows,$tpl_result);
    $tpl_full = preg_replace("/{RESULT}/si",$tpl_result,$tpl_full);
    $tpl_full = preg_replace("/{NORESULT}/si","",$tpl_full);
    xinabse_debug("using block","RESULT");
  }else{
    //if no hits were returned use just print the NORESULT block
    $tpl_full = preg_replace("/{NORESULT}/si",$tpl_noresult,$tpl_full);
    $tpl_full = preg_replace("/{RESULT}/si","",$tpl_full);
    xinabse_debug("using block","NORESULT");
  }

  //fill other placeholders
  $output = $tpl_full;
  $output = preg_replace("/{QUERY}/si",$q,$output);
  $output = preg_replace("/{QQUERY}/si",htmlentities($q),$output);
  $output = preg_replace("/{HITCOUNT}/si",$rowcount,$output);
  $output = preg_replace("/{START}/si",$start,$output);
  $output = preg_replace("/{LIMIT}/si",$limit,$output);

  //calculate navigationurls
  if($start > 0){
    $prev = $start-($limit);
    $output = preg_replace("/{PREV (.*?)}/si",
                           '<A HREF="?q='.urlencode($q).
                                    '&tpl='.urlencode($tpl).
                                    '&limit='.$limit.
                                    '&start='.$prev.'">'."\\1".'</A>',
                            $output);
  }else{
    $output = preg_replace("/{PREV (.*?)}/si","&nbsp;",$output);
  }
  
  if($start < $rowcount-$limit && $rowcount>$limit){
    $next = $start+$limit;
    $output = preg_replace("/{NEXT (.*?)}/si",
                           '<A HREF="?q='.urlencode($q).
                                    '&tpl='.urlencode($tpl).
                                    '&limit='.$limit.
                                    '&start='.$next.'">'."\\1".'</A>',
                            $output);
  }else{
    $output = preg_replace("/{NEXT (.*?)}/si","&nbsp;",$output);
  }

  //print
  print($output);
  
?>
